/*
 *  plots2D.C
 *  
 *
 *  Created by Arian Abrahantes on 5/02/13.
 *  Copyright 2013 __MyCompanyName__. All rights reserved.
 *
 */


#include "Riostream.h"
#include "TString.h"
#include "TObject.h"

void plots2D(Int_t kColumn=7,Bool_t fDebug = kFALSE){
   
   
   //Bool_t kLeg = kFALSE;
   Bool_t kLeg = kTRUE;
   int kRebin = 1; // tb
   int nSkip = 10; //tanbeta
   //if you want to space markers over line (usually 8)
   const int kSkip = 30;
   //int nSkip = 0; //mgl
   
   //Bool_t doLable = kFALSE;
   Bool_t doLable = kTRUE;
   
   Bool_t doSubt = kFALSE;
   //Bool_t doSubt = kTRUE;
   
   TString outputDir="test/";
   TString outputName = "";
   
   TString inputLocation ="./";
   
   TString scenario = "52";
   TString deltax[]    = {"deltaLL12",""};
   TString deltay[]    = {"deltaLL23",""};
   Double_t extractValueX=0.000001;

   
   const double kScale=1.e0;
   //cuts on axis
   Double_t x1[2];
   x1[0]=-0.8;
   x1[1]=.8;
   Double_t y1[2];
   y1[0]=-.8;
   y1[1]=.8;
   Double_t y2[2];
   Double_t higgsMassExpVal = 126.0;
   Double_t higgsMassExpErr = 2.0;

   
   
   Int_t nFiles = checkSize(deltax);
   if (fDebug) cout << nFiles << " Files read "<< endl;
   
   TString fileName[20];
   TString legendString[20];
   for(Int_t iFile=0;iFile<nFiles;iFile++){
      fileName[iFile]=Form("%sscenario-%s/%s-%s/salida-%s-resumado_fh.out",inputLocation.Data(),scenario.Data(),deltax[iFile].Data(),deltay[iFile].Data(),scenario.Data());

   }
   
   int maxRows =0;
   const int maxCol = 20;
   const int maxRow = 40000;
   double x[maxCol][maxRow];
   double ratio[maxRow];
   double ratio1[maxRow];
   double xratio1[maxRow],yratio1[maxRow];
   int n = 0;
   int cSum =0;
   
   //gROOT->Reset();
   //gROOT->SetStyle("MYSTYLE");
   
   Int_t colors[3] = {kRed, kYellow, kGreen};
   gStyle->SetPalette(3,colors);
   gROOT->ForceStyle();


   //Higgs Mass
   TGraph2D* graph;
   TH2D *hgraph;
   //Brbsg 
   TGraph2D* gRatio;
   TH2D *hgraph1;
   //Br tcgamma
   TGraph2D *grtcgamma;
   TH2D *htcgamma;
   //Br tcgluon
   TGraph2D *grtcgluon;
   TH2D *htcgluon;
   //Br tcgluon
   TGraph2D *grtcZ;
   TH2D *htcZ;
   
   Double_t maxY=-100;
   Double_t minY=100;
   Double_t maxX1=-100;
   Double_t minX1=100;
   Double_t maxX2=-100;
   Double_t minX2=100;

   for (int iFile=0; iFile<nFiles; iFile++) {
      Int_t kLineStyle = iFile%(nFiles);
      if (iFile==0 || iFile==1) kLineStyle=1;
      else if (iFile==2 || iFile==3) kLineStyle=7;
      else if (iFile==5 || iFile==4) kLineStyle=9;
      else if (iFile==6 || iFile==7) kLineStyle=3;
      else if (iFile==8 || iFile==9) kLineStyle=10;
      
      cout << fileName[iFile]<<endl;
      //double x[maxCol][maxRow];
      
      n = 0;
      Int_t iColumn = kColumn;
      readFile(fileName[iFile],iFile,x,n,nSkip, fDebug,x1,y1);
      //loop over values
      // scale y-axis of TGraph
      // if passing to other parameterization save ratio graph and clear ratio
      cout << "====columns >>>> " << n << endl ;
      int countBr=0;
      for (int i=0;i<n;i++) {
         x[iColumn][i]=kScale*x[iColumn][i];
         if (iColumn==7) {
            ratio[i]=(x[iColumn][i]-higgsMassExpVal)/higgsMassExpErr;
            //ratio[i]=(x[iColumn][i]-higgsMassExpVal);
            cout << ratio[i] << endl;
            if (ratio[i] < minY) minY=ratio[i];
            if (ratio[i] > maxY) maxY=ratio[i];
            if (x[0][i]  < minX1) minX1=x[0][i];
            if (x[0][i]  > maxX1) maxX1=x[0][i];
            if (x[2][i]  < minX2) minX2=x[2][i];
            if (x[2][i]  > maxX2) maxX2=x[2][i];
            // check Br limits (BrbsgSm-BrbsgMSSM)/(2ErrBr)
            Double_t tempratio = TMath::Abs((x[5][i]-x[6][i]))/(2*0.03*x[5][i]);
            //this is exclussion plot
            if (tempratio > 3) {
               ratio1[countBr] =tempratio;
               xratio1[countBr] = x[0][i];
               yratio1[countBr] = x[2][i];
               countBr++;
               //cout << tempratio << endl;
            }
         }
         
         //cout << kScale<< " ==>> scaled ==>"<<x[iColumn][i]<<endl;
      }
      printf("====>>>> finish reading \n");
      //graph = new TGraph2D(n,x[0],x[2],x[iColumn]);
      graph = new TGraph2D(n,x[0],x[2],ratio);
      graph->SetName("Mass Graph");
      hgraph = new TH2D();
      hgraph = graph->GetHistogram();
      cout << "Built plot Higgs Mass" << endl;
      gRatio = new TGraph2D(countBr,xratio1,yratio1,ratio1);
      gRatio->SetName("Bsg Graph");
      hgraph1 = new TH2D();
      hgraph1 = gRatio->GetHistogram();
      cout << "Built plot Bsg" << endl;
   }
   
   TCanvas *canvas = new TCanvas("canvas","canvas",10,10,1000,400);
   canvas->UseCurrentStyle();
   
   int count = 0;
   canvas->Divide(2,1);
   
   canvas->cd(1);
   //hgraph->SetContour(11,contours);

   const Int_t nCont=5;
   double contours[nCont];
   contours[0] = 0.35;
   contours[1] = 0.45;
   contours[2] = 0.55;
   contours[3] = 0.75;
   contours[4] = 0.9;
   
   hgraph->SetContour(nCont,contours);
   hgraph->Draw("CONT Z LIST");
   canvas->Update(); // Needed to force the plotting and retrieve the contours in TGraphs
   canvas->cd(2);
   hgraph->DrawCopy("surf3");
   //hgraph->DrawCopy("cont z 3");
   canvas->Update();
   
   // Get Contours
   TObjArray *conts = (TObjArray*)gROOT->GetListOfSpecials()->FindObject("contours");
   TList* contLevel = NULL;
   TGraph* curv     = NULL;
   TGraph* gc       = NULL;
   
   Int_t nGraphs    = 0;
   Int_t TotalConts = 0;
   
   if (conts == NULL){
      printf("*** No Contours Were Extracted!\n");
      TotalConts = 0;
      return;
   } else {
      TotalConts = conts->GetSize();
   }
   
   printf("TotalConts = %d\n", TotalConts);
   
   for(i = 0; i < TotalConts; i++){
      contLevel = (TList*)conts->At(i);
      printf("Contour %d has %d Graphs\n", i, contLevel->GetSize());
      nGraphs += contLevel->GetSize();
   }
   
   nGraphs = 0;
   
   TCanvas* c1 = new TCanvas("c1","Contour List",10,10,550,400);
   
   
   TH2F *hr = new TH2F("hr",
                       "#splitline{Negative contours are returned first (highest to lowest). Positive contours are returned from}{lowest to highest. On this plot Negative contours are drawn in red and positive contours in blue.}",
                       50, 1.05*minX1, 1.05*maxX1,50, 1.05*minX2, 1.05*maxX2);
   
   hr->Draw();
   
   Double_t x0, y0, z0;
   TLatex l;
   l.SetTextSize(0.04);
   char val[20];
   
   for(i = 0; i < TotalConts; i++){
      contLevel = (TList*)conts->At(i);
      if (i<3) z0 = contours[2-i];
      else     z0 = contours[i];
      printf("Z-Level Passed in as:  Z = %f\n", z0);
      
      // Get first graph from list on curves on this level
      curv = (TGraph*)contLevel->First();
      for(Int_t j = 0; j < contLevel->GetSize(); j++){
         curv->GetPoint(0, x0, y0);
         if (z0<0) curv->SetLineColor(kRed);
         if (z0>0) curv->SetLineColor(kBlue);
         nGraphs ++;
         printf("\tGraph: %d  -- %d Elements\n", nGraphs,curv->GetN());
         
         // Draw clones of the graphs to avoid deletions in case the 1st
         // pad is redrawn.
         gc = (TGraph*)curv->Clone();
         gc->Draw("L");
         
         sprintf(val,"%g",z0);
         l.DrawLatex(x0,y0,val);
         curv = (TGraph*)contLevel->After(curv); // Get Next graph
      }
   }
   c1->Update();
   
   
   double contours1[1];
   contours1[0] = 5;
   
   hgraph1->SetContour(1,contours1);
   hgraph1->SetLineColor(kRed);
   
   
   // Get Contours of Br
   TCanvas* c2 = new TCanvas("c2","Br",10,10,550,400);
   c2->Divide(2,1);

   c2->cd(1);
   hgraph1->Draw("cont LIST");
   c2->cd(2);
   //hgraph1->Draw("cont0");
   hgraph1->Draw("surf3");
   //hgraph1->Draw("lego");
   c2->Update();
   
   
   TObjArray *conts1 = (TObjArray*)gROOT->GetListOfSpecials()->FindObject("contours");
   
   TotalConts=0;
   
   if (conts1 == NULL){
      printf("*** No Contours of Br Were Extracted!\n");
      TotalConts = 0;
      return;
   } else {
      TotalConts = conts1->GetSize();
      printf("*** %d Contours of Br Were Extracted!\n",TotalConts);
   }
   
   nGraphs=0;
   
   for(i = 0; i < TotalConts; i++){
      contLevel = (TList*)conts1->At(i);
      printf("Contour %d with z=%d has %d Graphs\n", i, contours1[i],contLevel->GetSize());
      nGraphs += contLevel->GetSize();
   }
   
   for(i = 0; i < TotalConts; i++){
      contLevel = (TList*)conts1->At(i);
      z0 = contours1[i];
      printf("Contour %d Z-Level Passed in as:  Z = %f\n", i, z0);
      
      // Get first graph from list on curves on this level
      curv = (TGraph*)contLevel->First();
      for(Int_t j = 0; j < contLevel->GetSize(); j++){
         curv->GetPoint(0, x0, y0);
         //if (z0<0) curv->SetLineColor(kRed);
         curv->SetLineColor(kRed);
         nGraphs ++;
         printf("\tGraph: %d  -- %d Elements\n", nGraphs,curv->GetN());
         
         // Draw clones of the graphs to avoid deletions in case the 1st
         // pad is redrawn.
         gc = (TGraph*)curv->Clone();
         gc->SetLineWidth(2);
         c1->cd();
         gc->Draw("L");

         sprintf(val,"%g",z0);
         l.DrawLatex(x0,y0,val);
         curv = (TGraph*)contLevel->After(curv); // Get Next graph
      }
   }
   c1->cd(1);
   gROOT->Reset();
   gStyle->SetPalette(3,colors);
   gROOT->ForceStyle();
   hgraph1->UseCurrentStyle();
   hgraph1->SetLineColor(kBlue);
   //hgraph1->DrawCopy("cont2 same");
   hgraph1->DrawCopy("col same");
   c1->Update();
   
   contoursex1(hgraph1);
   
}

void readFile(TString file, int iFile, double x[20][40000], int &n, const int nskip, const Bool_t fDebug=kFALSE, 
              Double_t limitX[2], Double_t limitY[2], const int maxCol=20, const int maxRow=40000){
   //void readFile(TString file, int iFile){
   // Read in data sets from file and insert into an array.
   // For file with n colums, data will go into a x[i][j]
   // where i = column number and j = rolw (line) number.
   // To access a 1-d array for a single column i use x[i].
   
   //TString fileName;
   //cout << "File name: "<< fileName[iFile]<<endl;
   //cin >> fileName;
   
   //   const int maxCol = 10;
   //   const int maxRow = 500;
   
   double u[maxCol];
   //double x[maxCol][maxRow];
   
   //clear x multiarrray x
   
   
   ifstream inFile;
   inFile.open(file);
   if (inFile.fail()) { 
      cout << "Couldn't open file!" << endl;
      exit(1); 
   }
   
   bool readLine = true;
   int lineNum = 0;
   int ncol;
   int countSkip = -1 ;
   while ( readLine ){
      
      TString line;
      stringstream ss;
      line.ReadLine(inFile);
      readLine = inFile.good();
      
      if ( readLine ) {
         
         TString firstChar = line(0,1);
         bool useLine = firstChar != "#";       // # for comment line
         
         if ( useLine ){
            
            //insert a trick to skip points 
            countSkip++;
            bool skipIt = countSkip%nskip == 0; 
            if (!skipIt) {
               continue;
            }
            if (fDebug) cout <<"input line : " << line.Data()<< endl;
            int i = 0;
            stringstream ss;
            ss << line;              // put whole line into ss
            TString token;
            bool getToken = true;
            
            while ( getToken ) {
               ss >> token;           // extracts one token
               if ( token.Length() > 0 && !TMath::IsNaN(token.Atof())) {
                  //cout << "token =" << token.Atof() << endl;
                  u[i] = token.Atof();
                  i++;
               } 
               else {
                  getToken = false;
               }
            }             // getToken
            ncol = i;  
            
            //limit x[0]
            //firt lower bound
            //cout <<"cut away by lower bound="<<limitX[0]<<" x="<<u[0]<<endl;
            if (u[0]<limitX[0] ) {if (fDebug) cout <<"cut away by lower bound "<< u[0]<< " " << u[2]<< endl; continue;}
            if (u[0]>limitX[1] ) {if (fDebug) cout <<"cut away by upper bound "<< u[0]<< " " << u[2]<<endl; break;}
            if (u[2]<limitY[0] ) {if (fDebug) cout <<"cut away by lower bound "<< u[0]<< " " << u[2]<< endl; continue;}
            if (u[2]>limitY[1] ) {if (fDebug) cout <<"cut away by upper bound "<< u[0]<< " " << u[2]<<endl; continue;}
            
            for (int i=0; i<ncol; i++){
               //if (!iFile) x[i][lineNum] = u[i];
               //else if(i) x[i][lineNum] = u[i];
               x[i][lineNum] = u[i];
            }
            lineNum++;
            
         }               // useLine
         
      }         // readLine
      
   }           // readLine
   
   inFile.close(); 
   n = lineNum;
   lineNum = 0;
   if (fDebug){
      cout << "read " << n << " lines" << endl;
      for (int i=0; i<n; i++){
         cout << i << " \t " << x[0][i] << " \t " << x[1][i] << " \t " 
         << x[2][i] << endl;
      }
   }
   //exit(1);
}

TCanvas* drawgraph(TH2 *f2){
   //get object name
   TString name = f2->GetName();
   cout<<"hist name " << name.Data()<<endl;
   TCanvas *c  = new TCanvas(name.Data(),name.Data(),0,0,800,700);
   c->cd();
   f2->SetContour(8);
   f2->Draw("surf3");
   return c;
}

TCanvas* contoursex1(TH2 *f2){
   
   //gROOT->Reset();
   //gROOT->SetStyle("BABAR");
   
   TCanvas *c  = new TCanvas("c","Contours",0,0,800,700);
   c->Divide(2,3,0,0);
   
   //TF2 *f2 = new TF2("f2","0.1+1000*((1-(x-2)*(x-2))*(1-(y-2)*(y-2)))",1,3,1,3);  
   f2->SetFillStyle(1000);
   f2->SetLineWidth(1);
   
   double contours[3];
   contours[0] = 5;
   contours[1] = 1000;
   contours[2] = 3000;
   f2->SetContour(3,contours);
   
   //gROOT->Reset();
   Int_t colors[3] = {kRed, kYellow, kGreen};
   gStyle->SetPalette(3,colors);
   
   c->cd(1);  
   //f2->Draw("cont0 z");
   //f2->Draw("colz");
   //f2->Draw("cont3 same");
   f2->Draw("cont4");
            
   /*c->cd(2);  
   c_2->SetLogx();
   c_2->SetLogy();
   c_2->SetLogz();
   f2->Draw("cont0 z");
   f2->Draw("cont3 same");*/
   
   c->cd(3);  
   f2->Draw("cont4 z");
   f2->Draw("cont3 same");
   
   /*c->cd(4);  
   c_4->SetLogx();
   c_4->SetLogy();
   c_4->SetLogz();
   f2->Draw("cont4 z");*/
   
   c->cd(5);  
   f2->Draw("colz");
   f2->Draw("cont3 same");
   
   /*c->cd(6);  
   c_6->SetLogx();
   c_6->SetLogy();
   c_6->SetLogz();
   f2->Draw("colz");
   f2->Draw("cont3 same");*/
   
   return c;
}

Int_t checkSize(TString *stringArray){
   Int_t count = 0;
   while(1){
      if ( stringArray[count].CompareTo("")){
         count++; 
      } else break;
   }
   return count;
}
